/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#ifndef _INCLUDE_XMEMOFUNC_H
#define _INCLUDE_XMEMOFUNC_H



#define		RC_SUCCESS	0
#define		RC_ERROR	-1



/* xmemo.c */

int xmemo_Param ( int, char** ) ;

/* xmemoapp.c */

void		xmemo_StatusMsg ( char* ) ;
int 		xmemo_InitWindow ( int, char** ) ;
int 		xmemo_ExitWindow ( ) ;

/* xmemochain.c */

zChainType* xmemo_InsertIntoChain ( zAnchorType*, void* ) ;
int 		xmemo_RemoveFromChain ( zAnchorType*, zChainType* ) ;

/* xmemoconf.c */

int 		xmemo_LoadOptionNetwork ( ) ;
int 		xmemo_SaveOptionNetwork ( ) ;
int 		xmemo_LoadOptionPreference ( ) ;
int 		xmemo_SaveOptionPreference ( ) ;
int 		xmemo_LoadOptionLog ( ) ;
int 		xmemo_SaveOptionLog ( ) ;
int 		xmemo_LoadOptionProfile ( ) ;
int 		xmemo_SaveOptionProfile ( ) ;
int 		xmemo_LoadOptionSystem ( ) ;
int 		xmemo_SaveOptionSystem ( ) ;

/* xmemodir.c */

int 		xmemo_CreateDirectory ( ) ;

/* xmemofile.c */

void		xmemo_FreeMemo ( zMemoType* ) ;
int 		xmemo_LoadMemoAll ( ) ;
int 		xmemo_SaveMemoAll ( ) ;
int 		xmemo_FreeMemoAll ( ) ;
zMemoType*	xmemo_CreateMemo ( ) ;
zMemoType*	xmemo_CopyMemo ( zMemoType* ) ;
int 		xmemo_InsertMemo ( zMemoType* ) ;
int 		xmemo_DeleteMemo ( zMemoType* ) ;
int 		xmemo_UpdateMemo ( zMemoType* ) ;

/* xmemolib.c */

int 		xmemo_CsvToken ( char**, int, char* ) ;
int 		xmemo_CheckNumeric ( char* ) ;
int 		xmemo_CheckNumericRange ( char*, int, int ) ;
void		kanji_euc_to_shiftjis ( char*, char* ) ;
void		kanji_jis_to_shiftjis ( char*, char* ) ;
void		kanji_shiftjis_to_euc ( char*, char* ) ;
void		kanji_shiftjis_to_jis ( char*, char* ) ;
int 		ShiftJIS_CRLF ( char*, char*, int, char*, char* ) ;
int 		ShiftJIS_To_JIS7 ( char*, char*, int, char, char ) ;
int 		ShiftJIS_To_JIS8 ( char*, char*, int, char, char ) ;
int 		ShiftJIS_To_EUC ( char*, char*, int, char, char ) ;
char*		ISO_DefaultDesignation_JIS ( ) ;
char*		ISO_DefaultDesignation_EUC ( ) ;
int 		ISO_To_ShiftJIS ( char*, char*, int, char*, char* ) ;

/* xmemolog.c */

void		xmemo_ErrorLog ( char*, char*, char* ) ;
void		xmemo_TraceLog ( char*, char* ) ;
void		xmemo_TracePacket ( char*, int ) ;

/* xmemonet.c */

#define		XMEMO_NET_NOTIFY_ENTER   	1
#define		XMEMO_NET_NOTIFY_REPLY   	2
#define		XMEMO_NET_NOTIFY_LEAVE   	3
#define		XMEMO_NET_NOTIFY_CHANGE 	4
#define		XMEMO_NET_NOTIFY_PRESENCE	5
#define		XMEMO_NET_NOTIFY_ABSENCE 	6

void		xmemo_DeleteUdpSocket ( zSocketType* ) ;
void		xmemo_DeleteTcpSocket ( zSocketType* ) ;
int 		xmemo_NetSend_MemberList ( zMemoType* ) ;
int 		xmemo_NetNotify ( zNetworkType*, int ) ;
int 		xmemo_NetNotify_Broadcast ( int ) ;
int 		xmemo_InitNetwork ( ) ;
int 		xmemo_ExitNetwork ( ) ;
long		ipaddress_string_to_long ( char* ) ;
char*		ipaddress_long_to_string ( long ) ;
int 		int_to_lobyte_first ( int ) ;
int 		int_to_hibyte_first ( int ) ;
int 		int_from_lobyte_first ( int ) ;
int 		int_from_hibyte_first ( int ) ;

/* xmemoneth.c */

void		xmemo_TimeoutUdp_Husen ( zMemberType* ) ;
void		xmemo_RecvUdp_Husen ( zSocketType*, long, short, char*, int ) ;
int 		xmemo_NetSend_Husen ( zMemberType*, zMemoType* ) ;
int 		xmemo_NetNotify_Husen ( int, long, short, int ) ;

/* xmemoneti.c */

void		xmemo_TimeoutUdp_Ipmsg ( zMemberType* ) ;
void		xmemo_RecvUdp_Ipmsg ( zSocketType*, long, short, char*, int ) ;
int 		xmemo_NetSend_Ipmsg ( zMemberType*, zMemoType* ) ;
int 		xmemo_NetNotify_Ipmsg ( int, long, short, int ) ;

/* xmemoneto.c */

void		xmemo_RecvUdp_Oboegaki ( zSocketType*, long, short, char*, int ) ;
void		xmemo_TimeoutConnectedTcp_Oboegaki ( zMemberType* ) ;
void		xmemo_TimeoutAcceptedTcp_Oboegaki ( zSocketType* ) ;
void		xmemo_RecvConnectedTcp_Oboegaki ( zMemberType*, char*, int ) ;
/*void		xmemo_RecvAcceptedTcp_Oboegaki ( zSocketType*, char*, int ) ;*/
/*void		xmemo_AcceptTcp_Oboegaki ( zSocketType*, void*, int, int ) ;*/
int 		xmemo_NetNotify_Oboegaki ( int, long, short, int ) ;

/* xmemotimer.c */

void		xmemo_StartTimer ( time_t ) ;



#endif
